/**
*Photo Manager App
* Implementing Photo Manager App
*/
var PhotoManagerApp = PhotoManagerApp || {};  //Define Photo Manager App namespace.
/**
*Constructor UNAS App
*/
PhotoManagerApp.App = function () {
    this.id = 'Photo Manager';
    this.name = 'Photo Manager';
    this.version = '6.4.169';
    this.active = false;
    this.menuIcon = '/apps/photomanager/images/logo.png';
    this.shortcutIcon = '/apps/photomanager/images/logo.png';
    this.entryUrl = '/apps/photomanager/album.html';
    //this.entryHelpUrl = '/apps/photomanager/album_help.html';
    var self = this;
    this.PhotoManagerAppWindow = function () {
    	if(UNAS.CheckAppState('Photo Manager')){
    		return false;
    	}
    	self.window=new MUI.Window({
            id: 'PhotoManagerAppWindow',
            title: UNAS._('Photo Manager'),
            icon: '/apps/photomanager/images/logo_small.png',
            loadMethod: 'xhr',
            width: 750,
            height: 480,
            maximizable: false,
            resizable: true,
            scrollbars: false,
            resizeLimit: { 'x': [750, 1200], 'y': [450, 900] },
            contentURL: '/apps/photomanager/album.html',
            require: {  css: ['/apps/photomanager/css/album.css'] },
            onBeforeBuild: function(){UNAS.SetAppOpenedWindow("Photo Manager",'PhotoManagerAppWindow')}
     	});
    };
    this.PhotoManagerUninstall = function (){
    	UNAS.RemoveDesktopShortcut('Photo Manager');
    	UNAS.RemoveMenu('Photo Manager');
    	//UNAS.RemoveAppFromGroups('Photo Manager', 'Help');
    	UNAS.RemoveAppFromGroups('Photo Manager', 'ControlPanel');
    	UNAS.RemoveAppFromApps('Photo Manager');
    };
    new UNAS.Menu('UNAS_App_Multimedia_Menu', this.name, this.menuIcon, 'Photo Manager', '', this.PhotoManagerAppWindow);
    new UNAS.DesktopShortcut(this.name, this.shortcutIcon, 'Photo Manager', this.PhotoManagerAppWindow);
    // new UNAS.RegisterToAppGroup(this.name, 'ControlPanel', {'Type' : 'Multimedia', 'Laction' : 8, "Icon": this.shortcutIcon, "Url": this.entryUrl},{});
    //new UNAS.RegisterToAppGroup(this.name, 'Help', {'Type' : 'Internet', 'Laction' : 3, "Icon": this.shortcutIcon, "Url": this.entryHelpUrl},{});
    var OnChangeLanguage = function (e) {
    	UNAS.SetMenuTitle('Photo Manager', UNAS._('Photo Manager')); //translate menu
        UNAS.SetShortcutTitle('Photo Manager', UNAS._('Photo Manager'));
        if (typeof self.window !== 'undefined') {
        	UNAS.SetWindowTitle('PhotoManagerAppWindow', UNAS._('Photo Manager'));
        }
    };
    UNAS.LoadTranslation('/apps/photomanager/languages/Translation', OnChangeLanguage);
    UNAS.Event.addEvent('ChangeLanguage', OnChangeLanguage);
    UNAS.CreateApp(this.name, this.shortcutIcon, this.PhotoManagerAppWindow, this.PhotoManagerUninstall);
};

new PhotoManagerApp.App();
