#!/bin/bash

setupython3pkgresources(){
	echo "python3-pkg-resources installing."

	for j in {1..5}; do
		# 安装软件包
		echo 'Y' | sudo apt-get install python3-pkg-resources=52.0.0-4
		
		# 验证安装
		if dpkg -s python3-pkg-resources &> /dev/null; then
			echo "安装成功"
			break
		fi
		echo "$j"
	done
	
}

setupython3setuptools(){
	echo "python3-setuptools installing."

	for j in {1..5}; do
		# 安装软件包
		echo 'Y' | sudo apt-get install python3-setuptools
		
		# 验证安装
		if dpkg -s python3-setuptools &> /dev/null; then
			echo "安装成功"
			break
		fi
		echo "$j"
	done
	
}

setupython3pip(){
	echo "python3-pip installing."

	for j in {1..5}; do
		# 安装软件包
		sudo apt-get install -y python3-pip
		
		# 验证安装
		if dpkg -s python3-pip &> /dev/null; then
			echo "安装成功"
			break
		fi
		echo "$j"
	done
	
}

setupip(){
	echo "pip installing."
	# cd /unas/apps/photomanager/sbin/ocr && sudo python3 get-pip.pyc
	# cd /unas/apps/photomanager/sbin/ocr && echo 'Y' | apt-get install  python3-pip 
	# echo 'Y' | sudo apt-get install python3-pkg-resources=52.0.0-4 
	# echo 'Y' | sudo apt-get install python3-setuptools
	# sudo apt-get install -y python3-pip

	setupython3pkgresources
	setupython3setuptools
	setupython3pip
	jq '.process = 10' "$dbpath"/process.json > "$dbpath"/tmp_process.json && mv "$dbpath"/tmp_process.json "$dbpath"/process.json
}


setupcnclip(){
	echo "cnclip installing."
	cd /unas/apps/photomanager/sbin/ocr/Chinese-CLIP/ 
	python3 -m pip install -i "$sourcepath"  -r requirements.txt  --no-cache-dir --target="$clippath"
	#jq '.process = 70' "$dbpath"/process.json > "$dbpath"/tmp_process.json && mv "$dbpath"/tmp_process.json "$dbpath"/process.json
	python3 -m pip install -i "$sourcepath" cn_clip==1.5.1 --no-cache-dir --target="$clippath"
	
	
	# dbpath=`php /unas/apps/photomanager/includes/getdbpath.php`
	# Path=`php /unas/apps/photomanager/includes/gethome.php`
	
	# if [ -d "$Path" ] && [ -f "$dbpath" ]; then
	#   echo "install chinese-clip model RN50"
	#   Dpath="$Path/.unas/apps/photomanager/.uphoto/"
	#   wget -c -P "$dbpath" https://clip-cn-beijing.oss-cn-beijing.aliyuncs.com/checkpoints/clip_cn_rn50.pt 
	# fi
}

setuppaddleocr(){
	echo "paddleocr installing."
	cd /unas/apps/photomanager/sbin/ocr/
	# python3 -m pip install paddlepaddle==3.0.0b1 -i https://www.paddlepaddle.org.cn/packages/stable/cpu/
	# python3 -m pip install paddlepaddle==2.5.2 -i https://pypi.tuna.tsinghua.edu.cn/simple
	# pip install -i https://mirrors.aliyun.com/pypi/simple/ PaddleOCR
	# pip install -i https://mirrors.aliyun.com/pypi/simple/ PPOCRLabel
	jq '.process = 10' "$dbpath"/process.json > "$dbpath"/tmp_process.json && mv "$dbpath"/tmp_process.json "$dbpath"/process.json
	ocrsourcepath="https://mirrors.aliyun.com/pypi/simple/"
	python3 -m pip install paddlepaddle==3.0.0b1 -i "$ocrsourcepath" --target="$paddlepath"
	#jq '.process = 20' "$dbpath"/process.json > "$dbpath"/tmp_process.json && mv "$dbpath"/tmp_process.json "$dbpath"/process.json
	python3 -m pip install PaddleOCR==2.8.1 -i "$ocrsourcepath" --target="$paddlepath"
	# jq '.process = 30' "$dbpath"/process.json > "$dbpath"/tmp_process.json && mv "$dbpath"/tmp_process.json "$dbpath"/process.json
	python3 -m pip install PPOCRLabel==2.1.8 -i "$ocrsourcepath" --target="$paddlepath"
	
	
}
setupfunc(){
	
	# jq '.AITASKSTATUS = 2 | .AIMODEL'$aimodel'STATUS = 2'  photomanager.json > tmp_file.json && mv tmp_file.json photomanager.json

	cp -r /unas/apps/photomanager/sbin/ocr/process.json "$dbpath"

	# pip
	if command -v pip &>/dev/null; then
		echo "pip is installed."
		jq '.process = 10' "$dbpath"/process.json > "$dbpath"/tmp_process.json && mv "$dbpath"/tmp_process.json "$dbpath"/process.json
	else
		echo "pip is not installed."
		setupip
	fi

	paddlepath="$dbpath/paddleocr/"
	clippath="$dbpath/Chinese-CLIP/"
	if [ -d "$paddlepath" ]; then
		echo "6"
		
	else
		mkdir "$paddlepath" 
	fi
	cp -r /unas/apps/photomanager/sbin/ocr/ocr.pyc "$dbpath"
	

	clippath="$dbpath/Chinese-CLIP/"
	if [ -d "$clippath" ]; then
		echo "6"
	else
		mkdir "$clippath" && cp -r /unas/apps/photomanager/sbin/ocr/Chinese-CLIP/* "$clippath" 
	fi
	cp -r /unas/apps/photomanager/sbin/facepython/scene.pyc "$dbpath"

	cp -r /unas/apps/photomanager/sbin/ocr/checkchineseclip.pyc "$dbpath"

	cp -r /unas/apps/photomanager/sbin/facepython/framerecongin.pyc "$dbpath"
	cp -r /unas/apps/photomanager/sbin/facepython/framescenerecongin.pyc "$dbpath"
	
	python3 -m pip install argparse==1.4.0 -i "$sourcepath" --target="$paddlepath"
	python3 -m pip install argparse==1.4.0 -i "$sourcepath" --target="$clippath"
	

	# PaddleOCR
	checkflag=$(cd "$dbpath" && python3 checkchineseclip.pyc 'PaddleOCR')
	echo $checkflag
	if [ $checkflag -eq 2 ]; then
		echo "paddleocr is not installed."
		setuppaddleocr
	else
		echo "paddleocr is installed."
		jq '.process = 60' "$dbpath"/process.json > "$dbpath"/tmp_process.json && mv "$dbpath"/tmp_process.json "$dbpath"/process.json
	fi

	for j in {1..5}; do
		
		checkflag=$(cd "$dbpath" && python3 checkchineseclip.pyc 'paddleocr')
		# 验证安装
		if [ $checkflag -eq 1 ]; then
			echo "安装成功"
			break
		else
			echo "paddleocr is not installed."
			setuppaddleocr
		fi
		echo "$j"
	done

	jq '.process = 40' "$dbpath"/process.json > "$dbpath"/tmp_process.json && mv "$dbpath"/tmp_process.json "$dbpath"/process.json
	echo "test paddleocr "
	cd "$dbpath/"
	python3 ocr.pyc '/unas/apps/photomanager/sbin/ocr/test.png' '/unas/apps/photomanager/sbin/ocr/test.txt'
	jq '.process = 50' "$dbpath"/process.json > "$dbpath"/tmp_process.json && mv "$dbpath"/tmp_process.json "$dbpath"/process.json
	if [ -f "/unas/apps/photomanager/sbin/ocr/test.txt" ]; then
		rm -rf '/unas/apps/photomanager/sbin/ocr/test.txt'
	fi
	jq '.process = 60' "$dbpath"/process.json > "$dbpath"/tmp_process.json && mv "$dbpath"/tmp_process.json "$dbpath"/process.json

	# Chinese-CLIP
	checkflag=$(cd "$dbpath" && python3 checkchineseclip.pyc 'cn_clip')
	echo $checkflag
	if [ $checkflag -eq 2 ]; then
		echo "cn_clip is not installed."
		setupcnclip
	else
		echo "cn_clip is installed."
	fi

	for j in {1..5}; do
		
		checkflag=$(cd "$dbpath" && python3 checkchineseclip.pyc 'cn_clip')
		# 验证安装
		if [ $checkflag -eq 1 ]; then
			echo "安装成功"
			break
		else
			echo "cn_clip is not installed."
			setupcnclip
		fi
		echo "$j"
	done


	jq '.process = 80' "$dbpath"/process.json > "$dbpath"/tmp_process.json && mv "$dbpath"/tmp_process.json "$dbpath"/process.json

	echo "install chinese-clip model $aimodelname"
	wget -c -P "$dbpath" https://clip-cn-beijing.oss-cn-beijing.aliyuncs.com/checkpoints/$aimodelname
	jq '.process = 90' "$dbpath"/process.json > "$dbpath"/tmp_process.json && mv "$dbpath"/tmp_process.json "$dbpath"/process.json

	# cd /unas/etc/photomanager/
	# jq '.AITASKSTATUS = 3 | .AIMODEL'$aimodel'STATUS = 3'  photomanager.json > tmp_file.json && mv tmp_file.json photomanager.json
	# jq '.process = 100' "$dbpath"/process.json > "$dbpath"/tmp_process.json && mv "$dbpath"/tmp_process.json "$dbpath"/process.json

	#the only one 
	if [ $defaultmodel -eq 0 ]; then
		jq '.DEFAULTMODEL = '$aimodel' '  photomanager.json > tmp_file.json && mv tmp_file.json photomanager.json
	fi
}

# function checksetupinfo(){
	# echo "test paddleocr "
	# cd "$dbpath/"
	# python3 ocr.pyc '/unas/apps/photomanager/sbin/ocr/test.png' '/unas/apps/photomanager/sbin/ocr/test.txt'
	# jq '.process = 50' "$dbpath"/process.json > "$dbpath"/tmp_process.json && mv "$dbpath"/tmp_process.json "$dbpath"/process.json
	# if [ -f "/unas/apps/photomanager/sbin/ocr/test.txt" ]; then
	# 	rm -rf '/unas/apps/photomanager/sbin/ocr/test.txt'
	# fi
	# jq '.process = 60' "$dbpath"/process.json > "$dbpath"/tmp_process.json && mv "$dbpath"/tmp_process.json "$dbpath"/process.json

	
	# python3 scene.pyc '/unas/apps/photomanager/sbin/ocr/test.png' '/unas/apps/photomanager/sbin/ocr/test.txt'
	# jq '.process = 50' "$dbpath"/process.json > "$dbpath"/tmp_process.json && mv "$dbpath"/tmp_process.json "$dbpath"/process.json
	# if [ -f "/unas/apps/photomanager/sbin/ocr/test.txt" ]; then
	# 	rm -rf '/unas/apps/photomanager/sbin/ocr/test.txt'
	# fi
	# jq '.process = 60' "$dbpath"/process.json > "$dbpath"/tmp_process.json && mv "$dbpath"/tmp_process.json "$dbpath"/process.json

# }

cd /unas/etc/photomanager/
dbpath=`php /unas/apps/photomanager/includes/getdbpath.php`
dbpath=$(dirname "$dbpath")/
# sourcepath="https://mirrors.aliyun.com/pypi/simple/"
sourcepath="https://pypi.tuna.tsinghua.edu.cn/simple/"
# sourcepath="https://pypi.mirrors.ustc.edu.cn/simple/"


aimodel=$1


aimodelarr=("" "clip_cn_rn50.pt" "clip_cn_vit-b-16.pt" "clip_cn_vit-l-14.pt" "clip_cn_vit-l-14-336.pt" "clip_cn_vit-h-14.pt") 
aimodelen=${#aimodelarr[@]}
if [ $aimodel -ge $aimodelen ]; then
	echo 1
	exit
fi
aimodelname=${aimodelarr[$aimodel]}
#echo $aimodelname

defaultmodel=$(jq -r '.DEFAULTMODEL' photomanager.json)
if [ $defaultmodel -eq 0 ]; then
	jq '.DEFAULTMODEL = '$aimodel' '  photomanager.json > tmp_file.json && mv tmp_file.json photomanager.json
fi


echo $dbpath
if [ -d $dbpath ]; then
	# echo 1
	
	jq '.AITASKSTATUS = 2 | .AIMODEL'$aimodel'STATUS = 2'  photomanager.json > tmp_file.json && mv tmp_file.json photomanager.json

	if [ $defaultmodel -ge 1 ]; then
		jq '.process = 50' "$dbpath"/process.json > "$dbpath"/tmp_process.json && mv "$dbpath"/tmp_process.json "$dbpath"/process.json
		echo "install chinese-clip model $aimodelname"
		wget -c -P "$dbpath" https://clip-cn-beijing.oss-cn-beijing.aliyuncs.com/checkpoints/$aimodelname
		jq '.process = 90' "$dbpath"/process.json > "$dbpath"/tmp_process.json && mv "$dbpath"/tmp_process.json "$dbpath"/process.json
	else 
		setupfunc
	fi
	cd /unas/etc/photomanager/
	jq '.AITASKSTATUS = 3 | .AIMODEL'$aimodel'STATUS = 3'  photomanager.json > tmp_file.json && mv tmp_file.json photomanager.json
	jq '.process = 100' "$dbpath"/process.json > "$dbpath"/tmp_process.json && mv "$dbpath"/tmp_process.json "$dbpath"/process.json
fi