#!/bin/bash


setupdeepface(){
	echo "deepface installing."
	deepfacepath="$dbpath/deepface-master/"
	facelogpath="$dbpath/facelog.log"
	# pip3 install --upgrade importlib-metadata

	cd "$dbpath/"

	if ! res=$(wget -q --show-progress -c -P "$dbpath" "$debappurl/faceai.zip" > "$facelogpath" 2>&1 ); then
		# error
		echo "error: $res"
	else
		echo "success: $res"
		# check md5 hash?
		unzip -o -d "$dbpath" faceai.zip

		cd "$deepfacepath"
		# python3 -m pip download -i "$sourcepath" -r requirements.txt -d /root/pipdirectory/
		python3 -m pip install -r requirements.txt --no-index --find-links="$facelibpath"  --target="$facelibpath"
	fi
	
	

	
}

setupfunc(){
	cd /unas/apps/photomanager/sbin/ocr/

	cp -r /unas/apps/photomanager/sbin/facepython/faceprocess.json "$dbpath"
	cp -r /unas/apps/photomanager/sbin/facepython/facecheck.pyc "$dbpath"
	cp -r /unas/apps/photomanager/sbin/facepython/cluster.pyc "$dbpath"
	cp -r /unas/apps/photomanager/sbin/facepython/face_sql.pyc "$dbpath"
	cp -r /unas/apps/photomanager/sbin/facepython/checkdeepface.py "$dbpath"
	cp -r /unas/apps/photomanager/sbin/facepython/framerecongin.pyc "$dbpath"
	cp -r /unas/apps/photomanager/sbin/facepython/framescenerecongin.pyc "$dbpath"
	cp -r /unas/apps/photomanager/sbin/facepython/handlecluster.pyc "$dbpath"
	cp -r /unas/apps/photomanager/sbin/facepython/getsimilarface.pyc "$dbpath"
	cp -r /unas/apps/photomanager/sbin/ocr/uphoto_sql.pyc "$dbpath"
	cp -r /unas/apps/photomanager/sbin/ocr/checkchineseclip.pyc "$dbpath"

	#1.下载远程服务器的faceversion.json文件
	#2.比较远程的faceversion.json文件和本地faceversion.json中的版本信息是否一致？一致才可以继续下一步。
	#3.如果cpu支持AVX，则下载远程服务器的faceai-avx.tar.gz文件;如果cpu不支持AVX，则下载远程服务器的faceai-noavx.tar.gz文件;同时把实时进度放入facelog.log文件
	#4.检测下载的faceai.tar.gz文件md5值是否和本地faceversion.json值一致。一致才可以继续下一步。
	#5.删除本地的lib、model、deepface-master等文件夹
	#6.解压faceai.tar.gz文件
	#7.pip3安装到lib
	#8.所有安装完成后，把faceversion.json文件移动到lib/下。

	
	
	facelibpath="$dbpath/lib/"
	facemodel="$dbpath/model/.deepface/weights/"
	debappurl="http://testapps.u-nas.com/unas6/test/uphoto"
	if [ -d "$facelibpath" ]; then
		echo "6"
		
	else
		mkdir -p "$facelibpath" 
	fi

	if [ -d "$facemodel" ]; then
		echo "6"
		
	else
		mkdir -p "$facemodel"  
	fi
	
	
	cd "$dbpath/"
	# DeepFace
	for j in {1..5}; do
		
		cd "$dbpath/"
		checkflag=$(cd "$dbpath" && python3 checkdeepface.py 'DeepFace')
		echo $checkflag
		if [ $checkflag -eq 2 ]; then
			echo "DeepFace is not installed."
			setupdeepface
		else
			echo "DeepFace is installed."
			break
		fi
		echo "$j"
	done
	
	# wget -c -P "$facemodel" https://github.com/serengil/deepface_models/releases/download/v1.0/retinaface.h5
	# wget -c -P "$facemodel" https://github.com/serengil/deepface_models/releases/download/v1.0/facenet512_weights.h5

}

cd /unas/etc/photomanager/
dbpath=`php /unas/apps/photomanager/includes/getdbpath.php`
dbpath=$(dirname "$dbpath")/

facestatus=$(jq -r '.FACESTATUS' photomanager.json)


echo $dbpath
echo $facestatus
if [ -d $dbpath ]; then
	# echo 1

	# if [ -z "$facestatus" ] || [ $facestatus -ge 2 ]; then
	if [ $facestatus -ge 2 ]; then
		echo 1
	else 
		jq '.FACESTATUS = 2 '  photomanager.json > tmp_file.json && mv tmp_file.json photomanager.json
		setupfunc
	fi
	cd /unas/etc/photomanager/
	jq '.FACESTATUS = 3 '  photomanager.json > tmp_file.json && mv tmp_file.json photomanager.json
	
fi