jQuery.expr[':'].contains = function(a, i, m) {
  return jQuery(a).text().toUpperCase()
    .indexOf(m[3].trim().toUpperCase()) >= 0;
};

function openHelpWin() {
  UNAS.GetAppInfo('Unas Help').appStartFunc();
  if (jQuery('#desktopHiddenModal').length) {
    jQuery('#desktopHiddenModal').trigger('mousedown');
  }
}
jQuery(document).click(function(e) {
  e.stopPropagation();
  jQuery('#supported_languages').hide();
  jQuery("#system-info-list").hide();
})
jQuery(document).ready(function() {
  function EventNotification() {
    var NotifyOptions = {
      "closeButton": true,
      "debug": false,
      "newestOnTop": false,
      "progressBar": false,
      "positionClass": "toast-top-right",
      "preventDuplicates": false,
      "onclick": null,
      "showDuration": "300",
      "hideDuration": "1000",
      "timeOut": "60000",
      "extendedTimeOut": "1000",
      "showEasing": "swing",
      "hideEasing": "linear",
      "showMethod": "fadeIn",
      "hideMethod": "fadeOut"
    }
    var backgroundProcessTimer = null;
    var menu_event_notify = '<div><p style="font-size: 14px; font-weight:bold;padding:6px;">' + UNAS._("U-NAS Notification") + '</p></div>';
    //menu_event_notify += '<div><label>' + UNAS._("Welcome to U-NAS") + '</label></label></div>';
    menu_event_notify += '<div id="unas_menu_event"></div>';

    //toastr["info"](menu_event_notify);
    var NotifyToastr = toastr;
    NotifyToastr.info(menu_event_notify, "", NotifyOptions);
    //get notification from u-nas.com
    jQuery.ajax({
      url: "/desktop/php/Notify.php",
      type: "POST",
      async: true,
      timeout: 20000,
      dataType: 'json',
      data: {
        action: "notify",
        language: UNAS.CurrentLanguage
      },
      success: function(data) {
        if (data != "") {
          jQuery("#unas_menu_event").html(data);
        } else {
          jQuery("#unas_menu_event").html(UNAS._("Welcome to U-NAS"));
        }

      },
      error: function(XMLHttpRequest, textStatus, errorThrown) {}
    });
    //get error message
    function translateElements(id) {
      var rt = document.getElementById(id);
      var pageTranslators = window.top.UNAS.CreateNodesTranslators(rt.parentNode);
      for (var i = 0; i < pageTranslators.length; i++) {
        var node = pageTranslators[i].node; // original node
        var p = pageTranslators[i].translateProperty; //the attribues need to be translated
        node[p] = window.top.UNAS._(pageTranslators[i].originalText); //translate
      }
    }

    function RealTimeNotification() { //error notification.
      jQuery.ajax({
        url: "/apps/errormessage/includes/errormessage.php",
        type: "POST",
        async: true,
        dataType: 'json',
        data: {
          "action": "listerrormessage"
        },
        timeout: 30000,
        success: function(data) {
          //alert(JSON.stringify(data));
          errormessage_info = data;
          var len = data.length;
          if (len > 0) {
            //toastr.options = {
            var UNASWarningOptions = {
              "closeButton": true,
              "debug": false,
              "newestOnTop": false,
              "progressBar": false,
              "positionClass": "toast-top-right",
              "preventDuplicates": false,
              "onclick": null,
              "showDuration": "300",
              "hideDuration": "1000",
              "timeOut": "60000",
              "extendedTimeOut": "1000",
              "showEasing": "swing",
              "hideEasing": "linear",
              "showMethod": "fadeIn",
              "hideMethod": "fadeOut"
            }
            var error_monitor = '<div><p style="font-size: 14px; font-weight:bold;padding:6px;">' + UNAS._("Warning") + '</p></div>';
            error_monitor += '<div id="unas_error_monitor"></div>';

            //toastr["warning"](error_monitor);
            var UNASwarningToastr = toastr;
            UNASwarningToastr.warning(error_monitor, "U-NAS", UNASWarningOptions);

            var tr = '';
            for (var i = 0; i < len; i++) {
              tr += '<p>';
              tr += data[i].ERRORDES;
              tr += '</p>';
            }
            jQuery('#unas_error_monitor').html(tr);
            translateElements("unas_error_monitor");
          }
        },
        error: function(XMLHttpRequest, textStatus, errorThrown) {}
      });
    }
    setTimeout(RealTimeNotification, 1000);

    //Background Processes lists
    var UNASProcessOptions = {
      "closeButton": true,
      "debug": false,
      "newestOnTop": false,
      "progressBar": false,
      "positionClass": "toast-top-right",
      "preventDuplicates": false,
      "tapToDismiss": false,
      "onclick": null,
      "showDuration": "300",
      "hideDuration": "1000",
      "timeOut": "0",
      "extendedTimeOut": "0",
      "showEasing": "swing",
      "hideEasing": "linear",
      "showMethod": "fadeIn",
      "hideMethod": "fadeOut"
    }
    var process_monitor = '<div><p style="font-size: 14px; font-weight:bold;padding:6px;">U-NAS' + UNAS._("Processes") + '</p><button class="unas_button_content"  style="width:30px; height:18px;" onclick="backgroundProcessPre()"> < </button><button class="unas_button_content" style="width:30px; height:18px;" onclick="backgroundProcessNext()"> > </button><label id="backgroundProcessNum" align="right"></label></div>';
    process_monitor += '<div id="unas_process_monitor" ></div>';
    var themeImagesDir = '/desktop/themes/' + UNAS.Desktop.Theme.Dir + '/images/';
    //toastr["warning"](error_monitor);
    var UNASProcessToastr = toastr;
    UNASProcessToastr.options.onCloseClick = function() {
      if (backgroundProcessTimer) {
        clearTimeout(backgroundProcessTimer); //stop updating process
      }
      RealTimeProcessNotification.from = 0;
      //RealTimeProcessNotification.perPage;
      //RealTimeProcessNotification.total;
    }
    UNASProcessToastr.info(process_monitor, "", UNASProcessOptions);
    cancelProcessByID = function(id) {
      var ret = confirm(UNAS._("Are you sure to delete the process?"));
      if (!ret) {
        return; //not to delete process
      }
      //Do we need to confirm delete action before we call ajax to delete the task?
      jQuery.ajax({
        url: "/desktop/php/Notify.php",
        type: "POST",
        async: true,
        dataType: 'json',
        data: {
          "action": "deleteprocess",
          "ID": id
        },
        timeout: 30000,
        success: function(data) {
          //alert(data);
          //console.log(data);
        },
        error: function(XMLHttpRequest, textStatus, errorThrown) {
          alert(errorThrown);
        }
      });
    }


    function RealTimeProcessNotification() { //process notification.
      if (typeof RealTimeProcessNotification.from == 'undefined') {
        RealTimeProcessNotification.from = 0;
      }
      if (typeof RealTimeProcessNotification.perPage == 'undefined') {
        RealTimeProcessNotification.perPage = 20;
      }
      if (typeof RealTimeProcessNotification.total == 'undefined') {
        RealTimeProcessNotification.total = 0;
      }

      jQuery.ajax({
        url: "/desktop/php/Notify.php",
        type: "POST",
        async: true,
        dataType: 'json',
        data: {
          "action": "listprocesses",
          "start": RealTimeProcessNotification.from,
          "count": RealTimeProcessNotification.perPage
        },
        timeout: 30000,
        success: function(pdata) {
          //console.log(pdata);
          if (pdata.total) {
            RealTimeProcessNotification.total = pdata.total;
          }
          var data = pdata.data;
          var len = data.length;
          if (len && len >= 0) {
            //display the login user's processes. Administrator can see all processes
            /* php returned process has the following information:
                  $ret[]=array(
                    "ID"=>$row['id'],
                    "app"=>$row['app'],
                    "user"=>$row['user'],
                    "PID"=>$row['PID'],
                    "messageID"=>$row['messageID'],
                    "message"=>$row['message'],
                    "status"=>$row['status'],
                    "progress"=>$row['progress'],
                    "processName"=>$row['processName'],
                    "processDetail"=>$row['processDetail'],
                    "time"=>$row['time']
                  );
            */
            var tr = '<table  style="width:100%;font-size:12px;color: #ffffcc;  table-layout: fixed;">';
            for (var i = 0; i < len; i++) {
              tr += '<tr><td width="35%" align="left" style="overflow: hidden; white-space: nowrap;"><b style="color:Brown; font-weight:bold" title="' + UNAS._("User: ") + data[i].user + "\n" + UNAS._("App: ") + data[i].app + "\n" + UNAS._("Process: ") + data[i].processDetail + '">' + data[i].processName + "</b></td>" +
                '<td width="33%" align="left" style="width=100%; overflow: hidden;">' + '<progress id="' + data[i].ID + '" width="100%" max="100" value="' + data[i].progress + '">' + data[i].progress + '</progress></td>' +
                '<td width="18%" align="left" style="width=100%; overflow: hidden; white-space: nowrap;">' + data[i].progress + '</td>' +
                '<td width="7%" align="left" style="width=100%; overflow: hidden; white-space: nowrap;">' + '<img id="' + data[i].ID + '" src="' + themeImagesDir + 'cancel.png?v=6.1.17&" ' + 'onclick="cancelProcessByID(this.id);"' + ' ></img>' + "</td></tr>";
            }
            tr += '</table>';
            jQuery('#unas_process_monitor').html(tr);
            jQuery('#backgroundProcessNum').text(RealTimeProcessNotification.from + "/" + RealTimeProcessNotification.total);
            //translateElements('unas_process_monitor');
          }
          backgroundProcessTimer = setTimeout(RealTimeProcessNotification, 5000); //every 5sec update background processes
        },
        error: function(XMLHttpRequest, textStatus, errorThrown) {
          alert(errorThrown);
        }
      });
    }

    backgroundProcessPre = function() {
      RealTimeProcessNotification.from = RealTimeProcessNotification.from - RealTimeProcessNotification.perPage;
      if (RealTimeProcessNotification.from < 0) {
        RealTimeProcessNotification.from = 0;
      }
      if (backgroundProcessTimer) {
        clearTimeout(backgroundProcessTimer); //stop updating process
      }
      RealTimeProcessNotification();
    }
    backgroundProcessNext = function() {
      RealTimeProcessNotification.from = RealTimeProcessNotification.from + RealTimeProcessNotification.perPage;
      if (RealTimeProcessNotification.from > (Math.floor(RealTimeProcessNotification.total / RealTimeProcessNotification.perPage) * RealTimeProcessNotification.perPage)) {
        RealTimeProcessNotification.from = Math.floor(RealTimeProcessNotification.total / RealTimeProcessNotification.perPage) * RealTimeProcessNotification.perPage;
      }
      if (backgroundProcessTimer) {
        clearTimeout(backgroundProcessTimer); //stop updating process
      }
      RealTimeProcessNotification();
    }
    setTimeout(RealTimeProcessNotification, 1000); //every 5sec update background processes
  }

  // Yui.use(['mCustomScrollbar'],function(){
  // var mCustomScrollbar = Yui.mCustomScrollbar;
  jQuery('#menuAppsList').mCustomScrollbar({
    autoHideScrollbar: true,
    theme: "minimal"
  });

  // 设置桌面主体高度
  // debugger;
  // jQuery("#pageWrapper").css('height',window.innerHeight - jQuery('#desktopHeader').height() - jQuery('#dock').height());
  // window.onresize = function(){
  //     jQuery("#pageWrapper").css('height',window.innerHeight - jQuery('#desktopHeader').height() - jQuery('#dock').height());
  // }

  //生成不可见遮罩层
  var createHiddenModal = function(d) {
    var m = '<div id="desktopHiddenModal" class="hiddenModal"></div>';
    jQuery(m).insertBefore(d);
    jQuery("#desktopHiddenModal").on('mousedown', function(e) {
      // e.stopPropagation();
      jQuery(this).siblings(".deskTopToggleDisplay").css('display', 'none').siblings('img').removeClass('active');
      jQuery('.toggleDisplayHoverBlock').children('ul').css('display', 'none')
      jQuery(".hiddenModal").remove();
    });
  }

  // 桌面顶部底部栏图标按钮禁止右键
  jQuery("#unas-system-info").bind("contextmenu", function(e) {
    return false;
  });

  jQuery('#unas-system-info').on('click', function(e) {
    e.stopPropagation();
    jQuery("#system-info-list").toggle();
  })

  // 桌面顶部底部栏图标按钮事件监听
  jQuery(".desktopStatebarBtn > img").on('mouseup', function(e) {
    e.stopPropagation();
    jQuery(this).addClass('active');
    createHiddenModal(jQuery(this).siblings(".deskTopToggleDisplay"));

    var toggledisplay = jQuery(".deskTopToggleDisplay");
    // for(var i=0;i<toggledisplay.length;i++){
    //     if(toggledisplay.eq(i).attr("id") != jQuery(this).siblings(".deskTopToggleDisplay").attr("id")){
    //         toggledisplay.eq(i).css('display','none');
    //     }
    // }
    jQuery(this).siblings(".deskTopToggleDisplay").toggle();

    jQuery('#jv-closeMenuApps').on("click", function(ev) {
      ev.stopPropagation();
      jQuery("#desktopHiddenModal").siblings(".deskTopToggleDisplay").css('display', 'none').siblings('img').removeClass('active');
      jQuery('.toggleDisplayHoverBlock').children('ul').css('display', 'none')
      jQuery(".hiddenModal").remove();
    })

  });
  // 防止点击弹出块时冒泡执行父级操作
  jQuery('.deskTopToggleDisplay > ul > li').on("click", function(e) {
    e.stopPropagation();
    switch (e.currentTarget.id) {
      case 'menu-clock':
        MUI.clockWindow();
        break;
      case 'menu-changeLanguage':
        break;
      case 'menu-easySetup':
        UNAS.GetAppInfo('Control Panel').appStartFunc();
        //document.getElementById('Easy SetupDesktopShortcut') && document.getElementById('Easy SetupDesktopShortcut').click();
        break;
      case 'menu-message':
        EventNotification();
        break;
      case 'menu-monitor':
        jQuery('#resourcepanel').slideToggle();
        if (jQuery('#dbz').length == 0) {
          jQuery('#resourcepanel').load('/apps/resourcepanel/index.html').click(function() {
            jQuery('#resourcepanel').css('z-index', '1000000000');
          });
        } else {
          window.dbz.showResourcePanel();
          window.dbz.startUpdate();
        }
        break;
      case 'menu-help':
        UNAS.GetAppInfo('Unas Help').appStartFunc();
        //document.getElementById('Unas HelpDesktopShortcut') && document.getElementById('Unas HelpDesktopShortcut').click();
        break;
    }
    if (jQuery('#desktopHiddenModal').length && e.currentTarget.id != 'menu-changeLanguage') {
      jQuery('#desktopHiddenModal').trigger('mousedown');
    }
  }).hover(function(e) {
    jQuery(this).siblings().removeClass('active').children('ul').css('display', 'none').children('li').removeClass('active');
  }, function() {});
  jQuery('#User_Top_Menu > div').on('click', function(e) {
    e.stopPropagation();
    switch (e.currentTarget.id) {
      case 'easySetup':
        UNAS.GetAppInfo('Easy Setup').appStartFunc();
        break;
    }
    if (jQuery('#desktopHiddenModal').length) {
      jQuery('#desktopHiddenModal').trigger('mousedown');
    }
  })

  //二级弹出块监听函数
  jQuery('.toggleDisplayHoverBlock').hover(function(e) {
    jQuery(this).siblings().removeClass('active').children('ul').css('display', 'none');
    jQuery(this).children('ul').css('display', 'block');
  }, function(e) {
    var that = this;
    setTimeout(function() {
      jQuery(that).children('ul').css('display', 'none');
    }, 200);
  });
  jQuery('.toggleDisplayHoverBlock ul').hover(function(e) {
    e.stopPropagation();
    jQuery(this).parent().addClass('active');
  }, function(e) {
    e.stopPropagation();
    var that = this;
    // setTimeout(function(){
    //     jQuery(that).css('display','none').closest('.toggleDisplayHoverBlock').removeClass('active');
    // }, 200);
  });

  //桌面左上角菜单列表过滤事件
  jQuery('#appMenusearch').keyup(function() {
    jQuery('#appMenulist .li-app').hide().filter(":contains('" + (jQuery(this).val()) + "')").show();
  });

  //显示桌面事件
  // if (jQuery('#minimizeLinkCheck')){
  //     jQuery('#minimizeLinkCheck').on('click', function(e){
  //         e.stopPropagation();
  //         Yui.windows.minimizeAll();
  //     });
  // }
  // });
  jQuery('#jv-system-info-nav-left a').hover(function(e) {
    jQuery(this).addClass('tabactive').siblings().removeClass('tabactive');
    var id = jQuery(this).attr('type');
    var idsib = jQuery(this).siblings().attr('type');
    jQuery('#' + idsib).hide();
    jQuery('#' + id).show();
  }, function(e) {

  })

  // jQuery('#jv-system-info-nav-right a').on('click', function() {
  //   var type = jQuery(this).attr('type');
  //   switch (type) {
  //     case 'versio':
  //
  //       break;
  //     case 'officialwebsite':
  //
  //       break;
  //     case 'reboot':
  //
  //       break;
  //     case 'shutdown':
  //       // UNAS.GetAppInfo('Shutdown').appStartFunc();
  //       console.log(UNAS.GetAppInfo('Reboot'));
  //       break;
  //     default:
  //
  //   }
  // })

  jQuery("#jv-system-info-menu-app-list").mCustomScrollbar({
    autoHideScrollbar: true,
    theme: "minimal-dark"
  });
});
