initializeWindows = function(){
	MUI.parametricsWindow = function(){
		new MUI.Window({
			id: 'parametrics',
			title: UNAS._('Window Parameters'),
			loadMethod: 'xhr',
			contentURL: MUI.path.plugins + '/parametrics/index.html',
			width: 305,
			height: 110,
			x: 230,
			y: 180,
			padding: { top: 12, right: 12, bottom: 10, left: 12 },
			resizable: false,
			maximizable: false,
			require: {
				css: [ MUI.path.plugins + '/parametrics/css/style.css?v=6.1.17&'],
				js: [ MUI.path.plugins + '/parametrics/scripts/parametrics.js?v=6.1.17&'],
				onload: function(){
					if (MUI.addRadiusSlider) MUI.addRadiusSlider();
					if (MUI.addShadowSlider) MUI.addShadowSlider();
				}
			}
		});
	}
	if ($('parametricsLinkCheck')){
		$('parametricsLinkCheck').addEvent('click', function(e){
			new Event(e).stop();
			MUI.parametricsWindow();
		});
	}

	if ($('cascadeLink')){
		$('cascadeLink').addEvent('click', function(e){
			new Event(e).stop();
			MUI.arrangeCascade();
		});
	}

	if ($('tileLink')){
		$('tileLink').addEvent('click', function(e){
			new Event(e).stop();
			MUI.arrangeTile();
		});
	}

	if ($('minimizeLink')){
		$('minimizeLink').addEvent('click', function(e){
			new Event(e).stop();
			MUI.minimizeAll();
		});
	}

	if ($('closeLink')){
		$('closeLink').addEvent('click', function(e){
			new Event(e).stop();
			MUI.closeAll();
		});
	}

	if ($('minimizeLinkCheck')){
		$('minimizeLinkCheck').addEvent('click', function(e){
			new Event(e).stop();
			MUI.minimizeAll();
		});
	}

	// Deactivate menu header links
	$$('a.returnFalse').each(function(el){
		el.addEvent('click', function(e){
			new Event(e).stop();
		});
	});

	// <!-- 个性化设置  开始 -->
	var DesktopChangeThemeWindows={};
	 MUI.choosethemeWindow = function(){
	     DesktopChangeThemeWindows = new MUI.Window({
			id: 'choosetheme',
			title: UNAS._('Personalize'),
			loadMethod: 'xhr',
			width: 310,
			height: 350,
			maximizable: false,
			resizable: false,
			scrollbars: false,
			resizeLimit:  {'x': [300, 2500], 'y': [410, 2000]},
			contentURL: '/desktop/html/choosetheme.html',
			onContentLoaded: function(){
				$('desktopBackgroundLink').addEvent('click', function(e){
              		MUI.desktopBackgroundWindow();
                });
			}
		});
	}

    //Change Lanuage Event Handler
	UNAS.Event.addEvent('ChangeLanguage', function (e) {
	    if (typeof DesktopChangeThemeWindows !== 'undefined') {
	        UNAS.TranslateText(DesktopChangeThemeWindows.windowEl);
	        //your additional code for Language Change...
	    }
	});
	// <!-- 个性化设置 结束 -->

	// <!-- 个性化背景设置 开始 -->
	var DesktopWallpaperWindow={};
	MUI.desktopBackgroundWindow = function(){
	    DesktopWallpaperWindow = new MUI.Window({
			id: 'desktopBackground',
			title: UNAS._('Desktop Wallpaper'),
			loadMethod: 'xhr',
			maximizable: false,
			resizable: false,
			//scrollbars: false,
			minimizable: false,
			collapsible: false,
			//draggable: false,
			width: 610,
			height: 400,
			contentURL: '/desktop/html/desktop_background.html',
			onContentLoaded: function(){
				$('desktopBackground_closeButton').addEvent('click', function(e){
 					jQuery.noConflict();
					var tmp_cur_deskbg = jQuery('#tmp_cur_desktopbgname').attr('value');
					if(tmp_cur_deskbg != ''){
						//('#pageWrapper').css('background-image','url('+ui_mainpath+'/themes/desktop_bg/'+tmp_cur_deskbg+'.jpg)');
					}
				})
				}
		});
	}

	if ($('desktopBackgroundLinkCheck')) {
		$('desktopBackgroundLinkCheck').addEvent('click', function(e){
		new Event(e).stop();
			MUI.desktopBackgroundWindow();
		});
	}
    //Change Lanuage Event Handler
	UNAS.Event.addEvent('ChangeLanguage', function (e) {
	    if (typeof DesktopWallpaperWindow !== 'undefined') {
	        UNAS.TranslateText(DesktopWallpaperWindow.windowEl);
	        //your additional code for Language Change...
	    }
	});
	// <!-- 个性化背景设置 结束 -->

	MUI.myChain.callChain();

}

// Initialize MochaUI when the DOM is ready
window.addEvent('load', function(){
	MUI.myChain = new Chain();
	MUI.myChain.chain(
		function(){MUI.Desktop.initialize();},
		function(){MUI.Dock.initialize();},
		function(){initializeWindows();}
	).callChain();
	// This is just for the demo. Running it onload gives pngFix time to replace the pngs in IE6.
	$$('.desktopIcon').addEvent('click', function(){
		MUI.notification('Do Something');
	});
});

window.addEvent('unload', function(){
	// This runs when a user leaves your page.
});

//右键
var ContextMenu = new Class({
	//implements
	Implements: [Options,Events],

	//options
	options: {
		actions: {},
		menu: 'contextmenu',
		stopEvent: true,
		targets: 'body',
		trigger: 'contextmenu',
		offsets: { x:0, y:0 },
		onShow: $empty,
		onHide: $empty,
		onClick: $empty,
		fadeSpeed: 200
	},

	//initialization
	initialize: function(options) {
		//set options
		this.setOptions(options)

		//option diffs menu
		this.menu = $(this.options.menu);
		this.targets = $$(this.options.targets);

		//fx
		this.fx = new Fx.Tween(this.menu, { property: 'opacity', duration:this.options.fadeSpeed });

		//hide and begin the listener
		this.hide().startListener();

		//hide the menu
		this.menu.setStyles({ 'position':'absolute','top':'-900000px', 'display':'block' });
	},

	//get things started
	startListener: function() {
		/* all elemnts */
		this.targets.each(function(el) {
			/* show the menu */
			el.addEvent(this.options.trigger,function(e) {
				//enabled?
				if(!this.options.disabled) {
					//prevent default, if told to
					if(this.options.stopEvent) { e.stop(); }
					//record this as the trigger
					this.options.element = $(el);
					//position the menu
					this.menu.setStyles({
						top: (e.page.y + this.options.offsets.y),
						left: (e.page.x + this.options.offsets.x),
						position: 'absolute',
						'z-index': '2000'
					});
					//show the menu
					this.show();
				}
			}.bind(this));
		},this);

		/* menu items */
		this.menu.getElements('a').each(function(item) {
			item.addEvent('click',function(e) {
				if(!item.hasClass('disabled')) {
					this.execute(item.get('href').split('#')[1],$(this.options.element));
					this.fireEvent('click',[item,e]);
				}
			}.bind(this));
		},this);

		//hide on body click
		$(document.body).addEvent('click', function() {
			this.hide();
		}.bind(this));
	},

	//show menu
	show: function() {
		this.fx.start(1);
		this.fireEvent('show');
		this.shown = true;
		return this;
	},

	//hide the menu
	hide: function() {
		if(this.shown) {
			this.fx.start(0);
			this.fireEvent('hide');
			this.shown = false;
		}
		return this;
	},

	//disable an item
	disableItem: function(item) {
		this.menu.getElements('a[href$=' + item + ']').addClass('disabled');
		return this;
	},

	//enable an item
	enableItem: function(item) {
		this.menu.getElements('a[href$=' + item + ']').removeClass('disabled');
		return this;
	},

	//diable the entire menu
	disable: function() {
		this.options.disabled = true;
		return this;
	},

	//enable the entire menu
	enable: function() {
		this.options.disabled = false;
		return this;
	},

	//execute an action
	execute: function(action,element) {
		if(this.options.actions[action]) {
			this.options.actions[action](element,this);
		}
		return this;
	}
});

/* create the menu */
/*
window.addEvent('domready', function() {
	var context = new ContextMenu({
		targets: '.unas-desktop_taskbar',
		menu: 'context2menu',
		actions: {
			copy: function(element,ref) {
				element.setStyle('color','#090');
				alert('You selected the element that says: "' + element.get('text') + '."  I just changed the color green.');
				alert('Disabling the menu to show each individual action can control the menu instance.');
				ref.disable();
			}
		},
		offsets: { x: 2, y: 2 }
	});
});
*/
