var desktopMessage = (function($){
    var that;
    var obj = function(){
        this.msg_type = {
            error:[],
            warning:[],
            alert:[],
            all:[]
        };
        that = this;
    }
    obj.prototype = {
        ctrl: function(){
            $("#megList").on('click',function(e){
                e.stopPropagation();
            })
            $(".megListContent>ul>li").on('click',function(e){
                // console.log($(e.target).attr("msg-value"));
                $(e.target).addClass("active").siblings().removeClass("active");
                switch($(e.target).attr("msg-value")){
                    case 'error':
                        that.generateMsgItemDom(that.msg_type.error,false);
                    break;
                    case 'warning':
                        that.generateMsgItemDom(that.msg_type.warning,false);
                    break;
                    case 'alert':
                        that.generateMsgItemDom(that.msg_type.alert,false);
                    break;
                    case 'all':
                        that.generateMsgItemDom(that.msg_type.all,false);
                    break;
                }
            })
            $(".megListBtns>a").on('click',function(){
                that.megMore();
            })
            $(".megListBtns>button").on('click',function(){
                that.clearAll();
            })
            that.ajax({},true);
        },
        ajax: function(param,isInitReq){
            $.ajax({
                url:"/desktop/js/morkData/message.json",
                data:{},
                type: "POST",
                dataType: 'json',
                success: function(data){
                    if(data.count>0){
                        var mesCountStr = '<div id="megCount">'+ (data.count>99?"99+":data.count) +'</div>';
                        $("#unas-desktop_message").append(mesCountStr);
                    }
                    that.generateMsgItemDom(data.msg,isInitReq);
                }
            });
        },
        generateMsgItemDom: function(msg,isInit){
            var msgItemStr = '';
            if(msg.length){
                isInit && (that.msg_type.all = msg);

                for(var i=0;i<msg.length;i++){
                    if(isInit){
                        that.saveMsgType(msg[i]);
                    }
                    msgItemStr += '<div class="megItem">'+
                        '<div class="msgItemIcon"><img class="msgItemImg" src="/desktop/themes/default/images/msg_'+ msg[i].type +'.png?v=6.1.17" /></div>'+
                        '<div class="msgItemInfo">'+
                            '<div class="msgLine">'+ msg[i].info +'</div>'+
                            '<div class="msgTime">'+ that.formatTime(msg[i].time) +'</div>'+
                        '</div>'+
                        '<div class="msgItemCount"><span>1</span></div>'+
                    '</div>'
                }
            }else{
                msgItemStr = '<div class="noMegList">没有新的通知</div>';
            }

            if(isInit){
                var _div = $("<div class='msgItemsContainer'></div>");
                _div.append(msgItemStr);
                $(".megListContentItems")
                .append(_div)
                .mCustomScrollbar({
                    autoHideScrollbar:true,
                    theme:"minimal-dark"
                });
            }else{
                $(".megListContentItems .msgItemsContainer").html(msgItemStr);
            }
        },
        formatTime: function(millisecond){
            var t = new Date(millisecond);
            return t.getFullYear() + "-" + ( (t.getMonth()+1)<10?("0"+(t.getMonth()+1)):(t.getMonth()+1) ) + "-" + ( (t.getDate()<10)?('0'+t.getDate()):t.getDate() ) + " " + ( (t.getHours()<10)?('0'+t.getHours()):t.getHours() ) + ":" + ( t.getMinutes()<10?('0'+t.getHours()):t.getHours() ) + ":" + ( t.getSeconds()<10?('0'+t.getSeconds()):t.getSeconds() );
        },
        saveMsgType: function(msg){
            switch(msg.type){
                case 'error':
                    that.msg_type.error.push(msg);
                break;
                case 'warning':
                    that.msg_type.warning.push(msg);
                break;
                case 'alert':
                    that.msg_type.alert.push(msg);
                break;
            }
        },
        megMore: function(){
            alert("查看更多");
        },
        clearAll: function(){
            $("#megCount").remove();
            var noMegStr = '<div class="noMegList">没有新的通知</div>';
            $(".megListContentItems").html(noMegStr);
        }
    }
    return new obj();
})(jQuery);

desktopMessage.ctrl();